''  *** COMPILED WITH PropBasic VERSION 00.01.03  Aug 17, 2010 ***
                                                             '' Mandelbrot PBASIC Program
{ Mandelbrot_I                                              

  Demo of Mandelbrot Fractal                                
  see: http://kapslog.de/wissen/2010/mandelbrotmenge-einfach-selbst-programmiert/
  by CWE                                                    
  17.05.10: Shorter Vertical Sync, only one line            
            Added: Automatic search for most interesting quadrant
  18.05.10: Tasks for the Calculation                       
  20.05.10: 2-Dim Seek                                      
  26.05.10: Seek around the clock                           
  26.10.10: Scan around the clock                           
            middepth at center                              
                                                            
}                                                           
                                                            
                                                             '' Graphics from Beans Conway's Game of Life
                                                             '' 256x192 matrix 
                                                             '' Outputs to NTSC on Propeller Demo Board



CON                                                          'DEVICE P8X32A, XTAL1, PLL16X
  _ClkMode = XTAL1 + PLL16X                                 

  _XInFreq =   5000000                                       'FREQ 80_000_000





                                                             '' Define CONs
' ONE      con   65536                                       'ONE      con   65536

' Baud          =  "T115200"                                 'Baud       CON "T115200"




                                                             '' Define PINs
' SyncPin  PIN 12 OUTPUT ' Sync signal on pin 12 (Demo board) 'SyncPin  PIN 12 OUTPUT ' Sync signal on pin 12 (Demo board)

' VideoPin PIN 14 OUTPUT ' Video (black / white) signal on pin 14 (Demo board) 'VideoPin PIN 14 OUTPUT ' Video (black / white) signal on pin 14 (Demo board)

' CpSync   PIN 16 INPUT                                      'CpSync   PIN 16 INPUT

' StartCalc PIN 23 low                                       'StartCalc PIN 23 low

' ReadyOne  PIN 22                                           'ReadyOne  PIN 22

' ReadyTwo  PIN 21                                           'ReadyTwo  PIN 21

' Ready3    PIN 20                                           'Ready3    PIN 20

' Ready4    PIN 19                                           'Ready4    PIN 19

' TX          PIN 30 HIGH   ' Send data back to PC           'TX          PIN 30 HIGH   ' Send data back to PC




                                                             '' Define HUB variables
' HUB BYTE vidMem(6144)                                      'vidMem  HUB BYTE(6144) = 0

' HUB BYTE vidBuf(6144)                                      'vidBuf  HUB BYTE(6144) = 255

' HUB LONG XMinH                                             'XMinH    HUB LONG=0

' HUB LONG XMaxH                                             'XMaxH    HUB LONG=0

' HUB LONG YMinH                                             'YMinH    Hub Long=0

' HUB LONG YMaxH                                             'YMaxH    Hub Long=0

' HUB STRING valueStr(11)                                    'valueStr HUB STRING(11)




                                                             '' Define DATA (DATA, WDATA, LDATA)
'CR DATA 13,0                                                'CR DATA 13,0

                                                             '' none


                                                             '' Define TASKs
OBJ MonoVid: "MonoVid.spin"                                  'MonoVid  TASK

OBJ Calc1: "Calc1.spin"                                      'Calc1    TASK

OBJ Calc2: "Calc2.spin"                                      'Calc2    TASK

OBJ Calc3: "Calc3.spin"                                      'Calc3    TASK

OBJ Calc4: "Calc4.spin"                                      'Calc4    TASK




                                                             '' Define variables (LONGs only)
' vidAddr    VAR LONG                                        'vidAddr    VAR LONG

' bufAddr    VAR LONG                                        'bufAddr    VAR LONG

' x          VAR LONG                                        'x          VAR LONG

' y          VAR LONG                                        'y          VAR LONG

' x1          VAR LONG                                       'x1          VAR LONG

' y1          VAR LONG                                       'y1          VAR LONG

' seed       VAR LONG                                        'seed       VAR LONG

' temp       VAR LONG                                        'temp       VAR LONG

' temp1      VAR LONG                                        'temp1      VAR LONG

' value      VAR LONG                                        'value      VAR LONG

' xmin       var long = -131072 '-131072 '-2*one             'xmin       var long = -131072 '-131072 '-2*one

' xmax       var long = -65000 'ONE                          'xmax       var long = -65000 'ONE

' ymin       var long = -98304  '-1.5                        'ymin       var long = -98304  '-1.5

' ymax       var long = -32000 '98304                        'ymax       var long = -32000 '98304

' xstep      var long = 65000 '65000 '/ 2                    'xstep      var long = 65000 '65000 '/ 2

' ystep      var long                                        'ystep      var long


' help       var long                                        'help       var long



' scanangle  var long=0                                      'scanangle  var long=0

' deltaangle var long= 1000 '8191 = volle Umdrehung          'deltaangle var long= 1000 '8191 = volle Umdrehung

' scanradius var long                                        'scanradius var long


' xmid       var long                                        'xmid       var long

' ymid       var long                                        'ymid       var long

' mdepth     var long                                        'mdepth     var long


' scale      var long                                        'scale      var long

' rcount     var long=0                                      'rcount     var long=0






                                                             '' Variables for subroutine CountNeighbors


                                                             '' Define Subroutines


' Point          FUNC 2                                      'Point          FUNC 2

' Sine           func 1                                      'Sine           func 1

' Cosine         func 1                                      'Cosine         func 1

' Radar          func 2                                      'Radar          func 2

' CPlot          sub 3                                       'CPlot          sub 3

' Prt            Sub 1                                       'Prt            Sub 1

' NL             SUB                                         'NL             SUB

' PrtW           sub 1                                       'PrtW           sub 1

' getdepth       func 2                                      'getdepth       func 2




                                                             '' Start of main code
PUB __Program                                                'PROGRAM Start lmm 'pasd
  MonoVid_COG:=MonoVid.Init(@__DATASTART)                   
  Calc1_COG:=Calc1.Init(@__DATASTART)                       
  Calc2_COG:=Calc2.Init(@__DATASTART)                       
  Calc3_COG:=Calc3.Init(@__DATASTART)                       
  Calc4_COG:=Calc4.Init(@__DATASTART)                       
  __OFFSET := @__Init                                       
  CogInit(0, @_LMM_Entry, @__DATASTART)                     
                                                            
DAT                                                         
                  org           0                           
__Init                                                      
__RAM                                                       
                  mov           dira,__InitDirA             
                  mov           outa,__InitOutA             
                  jmp           #_LMM_JUMP                  
                  long          Start * 4                   


Start                                                        'Start:




                  mov           __temp1,#MonoVid_COG_ofs & $1FF '  COGSTART MonoVid
                  movd          __temp1,#MonoVid_COG_ofs >> 9
                  add           __temp1,par                 
                  rdlong        __temp1,__temp1             
                  add           __temp1,#8                  
                  coginit       __temp1                     

                  mov           __temp1,#Calc1_COG_ofs & $1FF '  COGSTART Calc1
                  movd          __temp1,#Calc1_COG_ofs >> 9 
                  add           __temp1,par                 
                  rdlong        __temp1,__temp1             
                  add           __temp1,#8                  
                  coginit       __temp1                     

                  mov           __temp1,#Calc2_COG_ofs & $1FF '  COGSTART Calc2
                  movd          __temp1,#Calc2_COG_ofs >> 9 
                  add           __temp1,par                 
                  rdlong        __temp1,__temp1             
                  add           __temp1,#8                  
                  coginit       __temp1                     

                  mov           __temp1,#Calc3_COG_ofs & $1FF '  COGSTART Calc3
                  movd          __temp1,#Calc3_COG_ofs >> 9 
                  add           __temp1,par                 
                  rdlong        __temp1,__temp1             
                  add           __temp1,#8                  
                  coginit       __temp1                     

                  mov           __temp1,#Calc4_COG_ofs & $1FF '  COGSTART Calc4
                  movd          __temp1,#Calc4_COG_ofs >> 9 
                  add           __temp1,par                 
                  rdlong        __temp1,__temp1             
                  add           __temp1,#8                  
                  coginit       __temp1                     


                  mov           __temp2,#300                 '  PAUSE 300                       ' Give tasks time to start
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0001                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#_LMM_JUMP          
                  long          __L0001 * 4                 



                  mov           scanradius,_20000            '  scanradius = 20000

__DO_1                                                       'do

                  mov           __remainder,xstep            '  scale = xstep / 128
                  and           __remainder,#127            
                  mov           scale,xstep                 
                  sar           scale,#7                    

                                                             '  scale = scale min 1
                  mins          scale,#1                    


                  adds          scanangle,deltaangle         '  inc scanangle, deltaangle

                  cmps          scanangle,_hex1fff WZ, WC    '  if scanangle > $1fff then
    IF_BE         jmp           #_LMM_JUMP                  
                  long          __ELSE_1 * 4                


                  subs          scanangle,_hex1fff           '    dec scanangle, $1fff

                  mov           __temp1,xstep                '    xstep = xstep * 9
                  mov           __temp2,#9                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0002                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0002 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           xstep,__temp1               

                  mov           __temp1,xstep                '    xstep = xstep / 10
                  mov           __temp2,#10                 
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #_LMM_JUMP                  
                  long          @__L0003 - @__Init          
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0004                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #_LMM_JUMP                  
                  long          @__L0004 - @__Init          
                  rcr           __temp2,#1                  
__L0005                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#_LMM_JUMP          
                  long          @__L0005 - @__Init          
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0003                                                     
                  mov           xstep,__temp4               


                  mov           __temp1,deltaangle           '    deltaangle = deltaangle *9
                  mov           __temp2,#9                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0006                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0006 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           deltaangle,__temp1          

                  mov           __temp1,deltaangle           '    deltaangle = deltaangle /10
                  mov           __temp2,#10                 
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #_LMM_JUMP                  
                  long          @__L0007 - @__Init          
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0008                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #_LMM_JUMP                  
                  long          @__L0008 - @__Init          
                  rcr           __temp2,#1                  
__L0009                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#_LMM_JUMP          
                  long          @__L0009 - @__Init          
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0007                                                     
                  mov           deltaangle,__temp4          

__ELSE_1                                                     '  endif
__ENDIF_1                                                   


                  mov           __paramcnt,#0                '  NL
                  jmp           #_LMM_CALL                  
                  long          NL_ret * 4                  
                  long          NL * 4                      

                  adds          rcount,#1                    '  inc rcount

                  mov           __param1,rcount              '  prt rcount
                  jmp           #_LMM_CALL                  
                  long          prt_ret * 4                 
                  long          prt * 4                     

                  mov           __param1,scanangle           '  prtW scanangle
                  jmp           #_LMM_CALL                  
                  long          prtW_ret * 4                
                  long          prtW * 4                    



__DO_2                                                       '  do

                  adds          scanradius,scale             '    inc scanradius, scale

                  mov           __param1,scanangle           '    xmid = cosine scanangle
                  jmp           #_LMM_CALL                  
                  long          @cosine_ret - @__Init       
                  long          @cosine - @__Init           
                  mov           xmid,__param1               

                  mov           __temp1,xmid                 '    xmid = xmid * scanradius
                  mov           __temp2,scanradius          
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0010                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0010 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           xmid,__temp1                

                  mov           __remainder,xmid             '    xmid = xmid / 2048
                  and           __remainder,_2047           
                  sar           xmid,#11                    


                  mov           __param1,scanangle           '    ymid = sine scanangle
                  jmp           #_LMM_CALL                  
                  long          @sine_ret - @__Init         
                  long          @sine - @__Init             
                  mov           ymid,__param1               

                  mov           __temp1,ymid                 '    ymid = ymid * scanradius
                  mov           __temp2,scanradius          
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0011                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0011 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           ymid,__temp1                

                  mov           __remainder,ymid             '    ymid = ymid / 2048
                  and           __remainder,_2047           
                  sar           ymid,#11                    

                  mov           __param1,xmid                '    mdepth = getdepth xmid,ymid
                  mov           __param2,ymid               
                  jmp           #_LMM_CALL                  
                  long          @getdepth_ret - @__Init     
                  long          @getdepth - @__Init         
                  mov           mdepth,__param1             

                  cmps          mdepth,#32 WZ, WC            '   loop until mdepth<32
    IF_AE         jmp           #_LMM_JUMP                  
                  long          __DO_2 * 4                  


__DO_3                                                       '  do

                  subs          scanradius,scale             '    dec scanradius, scale

                  mov           __param1,scanangle           '    xmid = cosine scanangle
                  jmp           #_LMM_CALL                  
                  long          @cosine_ret - @__Init       
                  long          @cosine - @__Init           
                  mov           xmid,__param1               

                  mov           __temp1,xmid                 '    xmid = xmid * scanradius
                  mov           __temp2,scanradius          
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0012                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0012 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           xmid,__temp1                

                  mov           __remainder,xmid             '    xmid = xmid / 2048
                  and           __remainder,_2047           
                  sar           xmid,#11                    


                  mov           __param1,scanangle           '    ymid = sine scanangle
                  jmp           #_LMM_CALL                  
                  long          @sine_ret - @__Init         
                  long          @sine - @__Init             
                  mov           ymid,__param1               

                  mov           __temp1,ymid                 '    ymid = ymid * scanradius
                  mov           __temp2,scanradius          
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0013                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0013 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           ymid,__temp1                

                  mov           __remainder,ymid             '    ymid = ymid / 2048
                  and           __remainder,_2047           
                  sar           ymid,#11                    

                  mov           __param1,xmid                '    mdepth = getdepth xmid,ymid
                  mov           __param2,ymid               
                  jmp           #_LMM_CALL                  
                  long          @getdepth_ret - @__Init     
                  long          @getdepth - @__Init         
                  mov           mdepth,__param1             

                  cmps          mdepth,#5 WZ, WC             '   loop until mdepth>5
    IF_BE         jmp           #_LMM_JUMP                  
                  long          __DO_3 * 4                  



                  mov           __param1,scanradius          '    prt scanradius
                  jmp           #_LMM_CALL                  
                  long          prt_ret * 4                 
                  long          prt * 4                     




                  mov           __temp1,xstep                '  ystep= xstep*192
                  mov           __temp2,#192                
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0014                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0014 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           ystep,__temp1               

                  mov           __remainder,ystep            '  ystep= ystep/256
                  and           __remainder,#255            
                  sar           ystep,#8                    


                  mov           xmin,xmid                    '  XMin = xmid - xstep
                  subs          xmin,xstep                  

                  mov           xmax,xmid                    '  XMAx = Xmid + xstep
                  adds          xmax,xstep                  

                  mov           ymin,ymid                    '  ymin = ymid - ystep
                  subs          ymin,ystep                  

                  mov           ymax,ymid                    '  ymax = ymid + ystep
                  adds          ymax,ystep                  


__DO_4                                                       '  do ' wait for cogs

                  and           ReadyOne,ina WZ, NR          '     temp= ReadyOne
    IF_Z          mov           temp,#0                     
    IF_NZ         mov           temp,#1                     

                  and           ReadyTwo,ina WZ, NR          '     help = ReadyTwo
    IF_Z          mov           help,#0                     
    IF_NZ         mov           help,#1                     

                                                             '     temp = temp + help
                  adds          temp,help                   

                  and           Ready3,ina WZ, NR            '     help = Ready3
    IF_Z          mov           help,#0                     
    IF_NZ         mov           help,#1                     

                                                             '     temp = temp + help
                  adds          temp,help                   

                  and           Ready4,ina WZ, NR            '     help = Ready4
    IF_Z          mov           help,#0                     
    IF_NZ         mov           help,#1                     

                                                             '     temp = temp + help
                  adds          temp,help                   

                  cmps          temp,#4 WZ, WC               '  loop until temp=4
    IF_NZ         jmp           #_LMM_JUMP                  
                  long          __DO_4 * 4                  


                  mov           __temp1,__XMinH_ofs          '  WRLONG XMinH, XMin
                  add           __temp1,par                 
                  wrlong        xmin,__temp1                

                  mov           __temp1,__XMaxH_ofs          '  WRLONG XMaxH, XMAx
                  add           __temp1,par                 
                  wrlong        xmax,__temp1                

                  mov           __temp1,__YMinH_ofs          '  WRLONG YMinH, YMin
                  add           __temp1,par                 
                  wrlong        ymin,__temp1                

                  mov           __temp1,__YMaxH_ofs          '  WRLONG YMaxH, YMax
                  add           __temp1,par                 
                  wrlong        ymax,__temp1                


                  or            dira,StartCalc               '  high StartCalc
                  or            outa,StartCalc              

                  mov           __temp2,#5                   '  pause 5
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0015                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#_LMM_JUMP          
                  long          __L0015 * 4                 

                  or            dira,StartCalc               '  low StartCalc
                  andn          outa,StartCalc              





                                                             '  'pause 2000
                  jmp           #_LMM_JUMP                   'loop
                  long          __DO_1 * 4                  
__LOOP_1                                                    



                  mov           __temp1,#0                   'END
                  waitpne       __temp1,__temp1             

                                                             ''###################################################################
NL                                                           'Sub NL

                  mov           __temp1,TX                   '    SEROUT TX, Baud, CR
                  mov           __temp5,__CR_ofs            
                  add           __temp5,par                 
__L0016                                                     
                  rdbyte        __temp2,__temp5 WZ          
                  adds          __temp5,#1                  
    IF_Z          add           __PC,#((__L0017-$)*4)-4     
                  or            __temp2,#256                
                  shl           __temp2,#1                  
                  mov           __temp3,#10                 
                  mov           __temp4,_115200baud         
                  add           __temp4,cnt                 
                  or            dira,__temp1                
__L0018                                                     
                  shr           __temp2,#1 WC               
                  muxc          outa,__temp1                
                  waitcnt       __temp4,_115200baud         
                  djnz          __temp3,#_LMM_JUMP          
                  long          __L0018 * 4                 
                  sub           __PC,#(($-__L0016)*4)+4     
__L0017                                                     

                  rdlong        __PC,__PC                    'endsub
NL_ret                                                      
                  long          0-0                         
                                                            


PrtW                                                         'sub PrtW

                  mov           __temp1,__param1             '    __param1 = __param1 * 360
                  mov           __temp2,#360                
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0019                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0019 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           __param1,__temp1            

                  mov           __temp1,__param1             '    __param1 = __param1 / $1fff
                  mov           __temp2,_hex1fff            
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #_LMM_JUMP                  
                  long          @__L0020 - @__Init          
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0021                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #_LMM_JUMP                  
                  long          @__L0021 - @__Init          
                  rcr           __temp2,#1                  
__L0022                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#_LMM_JUMP          
                  long          @__L0022 - @__Init          
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0020                                                     
                  mov           __param1,__temp4            

                  jmp           #_LMM_CALL                   '    Prt __param1
                  long          Prt_ret * 4                 
                  long          Prt * 4                     

                  rdlong        __PC,__PC                    'Endsub
PrtW_ret                                                    
                  long          0-0                         
                                                            


Prt                                                          'Sub Prt

                  mov           __temp1,__valueStr_ofs       '    valueStr = STR __Param1, 8, 3
                  add           __temp1,par                 
                  mov           __temp2,__param1            
                  mov           __temp4,#8-1                
                  mov           __temp3,#" "                
                  abs           __temp2,__temp2 WC          
                  mov           __temp5,#" "                
    IF_C          mov           __temp5,#"-"                
                  wrbyte        __temp5,__temp1             
                  add           __temp1,#1                  
__L0023                                                     
                  mov           __temp5,__temp3             
__L0024                                                     
                  cmpsub        __temp2,_1000000 WC, WR     
                  cmp           __temp4,#1 WZ               
    IF_C          mov           __temp3,#"0"                
    IF_C_OR_Z     min           __temp5,#"0"                
    IF_C          adds          __temp5,#1                  
    IF_C          jmp           #_LMM_JUMP                  
                  long          @__L0024 - @__Init          
                  wrbyte        __temp5,__temp1             
                  add           __temp1,#1                  
                  mov           __temp5,__temp2             
                  shl           __temp2,#2                  
                  add           __temp2,__temp5             
                  shl           __temp2,#1                  
                  djnz          __temp4,#_LMM_JUMP          
                  long          @__L0023 - @__Init          
                  mov           __temp5,#0                  
                  wrbyte        __temp5,__temp1             

                  mov           __temp1,__valueStr_ofs       '    valueStr = valueStr + 13
                  add           __temp1,par                 
                  mov           __temp2,__valueStr_ofs      
                  add           __temp2,par                 
__L0025                                                     
                  rdbyte        __temp3, __temp2 WZ         
                  wrbyte        __temp3, __temp1            
                  add           __temp1,#1                  
                  add           __temp2,#1                  
    IF_NZ         jmp           #_LMM_JUMP                  
                  long          @__L0025 - @__Init          
                  sub           __temp1,#1                  
                  mov           __temp3,#13                 
                  wrbyte        __temp3,__temp1             
                  add           __temp1,#1                  
                  mov           __temp3,#0                  
                  wrbyte        __temp3,__temp1             

                  mov           __temp1,TX                   '    SEROUT TX, Baud, valueStr
                  mov           __temp5,__valueStr_ofs      
                  add           __temp5,par                 
__L0026                                                     
                  rdbyte        __temp2,__temp5 WZ          
                  adds          __temp5,#1                  
    IF_Z          add           __PC,#((__L0027-$)*4)-4     
                  or            __temp2,#256                
                  shl           __temp2,#1                  
                  mov           __temp3,#10                 
                  mov           __temp4,_115200baud         
                  add           __temp4,cnt                 
                  or            dira,__temp1                
__L0028                                                     
                  shr           __temp2,#1 WC               
                  muxc          outa,__temp1                
                  waitcnt       __temp4,_115200baud         
                  djnz          __temp3,#_LMM_JUMP          
                  long          __L0028 * 4                 
                  sub           __PC,#(($-__L0026)*4)+4     
__L0027                                                     

                  rdlong        __PC,__PC                    'EndSub
Prt_ret                                                     
                  long          0-0                         
                                                            





Cosine                                                       'Func Cosine

'      anglec var long                                       '     anglec var long

'      cos    var long                                       '     cos    var long

                  mov           anglec,__param1              '     anglec = __param1 + $800
                  adds          anglec,_hex800              

                  mov           __param1,anglec              '     cos = sine anglec
                  jmp           #_LMM_CALL                  
                  long          @sine_ret - @__Init         
                  long          @sine - @__Init             
                  mov           cos,__param1                

                  mov           __param1,cos                 '     return cos
                  rdlong        __PC,__PC                   
Cosine_ret                                                  
                  long          0-0                         

                                                             'Endfunc



Sine                                                         'Func Sine 'angle from 0 to $1fff, result +/- 2048

'   angle     var long                                       '  angle     var long

'   quadrant  var long                                       '  quadrant  var long

'   index     var long                                       '  index     var long

'   sinus     var long                                       '  sinus     var long

'   angle2    var long                                       '  angle2    var long


                  mov           angle,__param1               '  angle= __param1

                  cmps          angle,_hex1fff WZ, WC        '  if angle> $1fff then
    IF_BE         jmp           #_LMM_JUMP                  
                  long          __ELSE_2 * 4                

                                                             '    angle = angle - $1fff
                  adds          angle,_minushex1fff         

                  jmp           #_LMM_JUMP                   '  elseif angle<0 then
                  long          __ENDIF_2 * 4               
__ELSE_2                                                    
                  cmps          angle,#0 WZ, WC             
    IF_AE         jmp           #_LMM_JUMP                  
                  long          __ELSE_3 * 4                

                                                             '    angle = angle + $1fff
                  adds          angle,_hex1fff              

__ELSE_3                                                     '  endif
__ENDIF_2                                                   


                  mov           __remainder,angle            '  quadrant= angle / $800
                  and           __remainder,_2047           
                  mov           quadrant,angle              
                  sar           quadrant,#11                


                  cmps          quadrant,#0 WZ, WC           '  if quadrant= 0 then
    IF_NE         jmp           #_LMM_JUMP                  
                  long          __ELSE_4 * 4                

                  mov           index,angle                  '    index = angle*2
                  shl           index,#1                    

                                                             '    index = $E000 + index
                  adds          index,_hexE000              

                  rdword        sinus,index                  '    rdword index, sinus


                  jmp           #_LMM_JUMP                   '  elseif quadrant= 1 then
                  long          __ENDIF_4 * 4               
__ELSE_4                                                    
                  cmps          quadrant,#1 WZ, WC          
    IF_NE         jmp           #_LMM_JUMP                  
                  long          __ELSE_5 * 4                

                  mov           angle2,_hex1000              '    angle2 = $1000 - angle
                  subs          angle2,angle                

                  mov           index,angle2                 '    index = angle2 * 2
                  shl           index,#1                    

                                                             '    index = index + $E000
                  adds          index,_hexE000              

                  rdword        sinus,index                  '    rdword index, sinus


                  jmp           #_LMM_JUMP                   '  elseif quadrant= 2 then
                  long          __ENDIF_4 * 4               
__ELSE_5                                                    
                  cmps          quadrant,#2 WZ, WC          
    IF_NE         jmp           #_LMM_JUMP                  
                  long          __ELSE_6 * 4                

                  mov           angle2,angle                 '    angle2 = angle - $1000
                  adds          angle2,_minushex1000        

                  mov           index,angle2                 '    index = angle2 * 2
                  shl           index,#1                    

                                                             '    index = $E000 + index
                  adds          index,_hexE000              

                  rdword        sinus,index                  '    rdword index, sinus

                  neg           sinus,sinus                  '    sinus= -sinus


                  jmp           #_LMM_JUMP                   '  elseif quadrant= 3 then
                  long          __ENDIF_4 * 4               
__ELSE_6                                                    
                  cmps          quadrant,#3 WZ, WC          
    IF_NE         jmp           #_LMM_JUMP                  
                  long          __ELSE_7 * 4                

                  mov           angle2,_hex1fff              '    angle2 = $1fff - angle
                  subs          angle2,angle                

                  mov           index,angle2                 '    index = angle2 * 2
                  shl           index,#1                    

                                                             '    index = $E000 + index
                  adds          index,_hexE000              

                  rdword        sinus,index                  '    rdword index, sinus

                  neg           sinus,sinus                  '    sinus= -sinus


__ELSE_7                                                     '  endif
__ENDIF_4                                                   

                  mov           __remainder,sinus            '  sinus = sinus/32 ' 32 ' Unsigned 16-bit samples in table!
                  and           __remainder,#31             
                  sar           sinus,#5                    

                  mov           __param1,sinus               '  return sinus
                  rdlong        __PC,__PC                   
Sine_ret                                                    
                  long          0-0                         


                                                             'endfunc




Radar                                                        'Func Radar 'angle1, angle2

'      ang1    var long                                      '     ang1    var long

'      ang2    var long                                      '     ang2    var long

'      ang     var long                                      '     ang     var long

'      qsum var long                                         '     qsum var long

'      pix  var long                                         '     pix  var long

'      oldpix var long                                       '     oldpix var long


                  mov           ang1,__param1                '     ang1 = __param1

                  mov           ang2,__param2                '     ang2 = __param2


                  mov           qsum,#0                      '     qsum =0

                  mov           ang,ang1                     '     for ang = ang1 to ang2 step 70
__FOR_ang_1                                                 

                  mov           __param1,ang                 '       x1 = Cosine ang
                  jmp           #_LMM_CALL                  
                  long          @Cosine_ret - @__Init       
                  long          @Cosine - @__Init           
                  mov           x1,__param1                 

                  mov           __temp1,x1                   '       x1 = x1 * 94
                  mov           __temp2,#94                 
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0029                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0029 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           x1,__temp1                  

                  mov           __temp1,x1                   '       x1 = x1 / $ffff
                  mov           __temp2,_hexffff            
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #_LMM_JUMP                  
                  long          @__L0030 - @__Init          
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0031                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #_LMM_JUMP                  
                  long          @__L0031 - @__Init          
                  rcr           __temp2,#1                  
__L0032                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#_LMM_JUMP          
                  long          @__L0032 - @__Init          
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0030                                                     
                  mov           x1,__temp4                  

                  adds          x1,#128                      '       inc x1, 128

                  mov           __param1,ang                 '       y1 = Sine ang
                  jmp           #_LMM_CALL                  
                  long          @Sine_ret - @__Init         
                  long          @Sine - @__Init             
                  mov           y1,__param1                 

                  mov           __temp1,y1                   '       y1 = y1 * 94
                  mov           __temp2,#94                 
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0033                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0033 - @__Init          
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1 WZ          
    IF_NZ         sub           __temp4,#1                  
                  mov           y1,__temp1                  

                  mov           __temp1,y1                   '       y1 = y1 / $ffff
                  mov           __temp2,_hexffff            
                  mov           __temp4,#0                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp5,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_Z          mov           __temp1,#0                  
    IF_Z          jmp           #_LMM_JUMP                  
                  long          @__L0034 - @__Init          
    IF_C          xor           __temp5,#1                  
                  mov           __temp3,#0                  
                  min           __temp2,#1                  
__L0035                                                     
                  add           __temp3,#1                  
                  shl           __temp2,#1 WC               
    IF_NC         jmp           #_LMM_JUMP                  
                  long          @__L0035 - @__Init          
                  rcr           __temp2,#1                  
__L0036                                                     
                  cmpsub        __temp1,__temp2 WC          
                  rcl           __temp4,#1                  
                  shr           __temp2,#1                  
                  djnz          __temp3,#_LMM_JUMP          
                  long          @__L0036 - @__Init          
                  test          __temp5,#1 WZ               
    IF_NZ         neg           __temp4,__temp4             
    IF_NZ         neg           __temp1,__temp1             
__L0034                                                     
                  mov           y1,__temp4                  

                  adds          y1,#95                       '       inc y1, 95


                  mov           __param1,x1                  '       pix = point x1, y1
                  mov           __param2,y1                 
                  jmp           #_LMM_CALL                  
                  long          @point_ret - @__Init        
                  long          @point - @__Init            
                  mov           pix,__param1                

                  mov           __param1,x1                  '       CPLOT x1,y1,1
                  mov           __param2,y1                 
                  mov           __param3,#1                 
                  jmp           #_LMM_CALL                  
                  long          CPLOT_ret * 4               
                  long          CPLOT * 4                   

                                                             '       'break
                  cmps          pix,oldpix WZ, WC            '       if pix <> oldpix then
    IF_E          jmp           #_LMM_JUMP                  
                  long          __ELSE_8 * 4                

                  adds          qsum,#1                      '          inc qsum

__ELSE_8                                                     '       endif
__ENDIF_8                                                   

                  mov           oldpix,pix                   '       oldpix = pix

                                                             '       'prt pix
                                                             '       'prt qsum
                                                             '       'pause 10
                  adds          ang,#70                      '     next ang
                  cmps          ang,ang2 WZ, WC             
    IF_BE         jmp           #_LMM_JUMP                  
                  long          __FOR_ang_1 * 4             
__NEXT_ang_1                                                

                  mov           __param1,qsum                '     return qsum
                  rdlong        __PC,__PC                   
Radar_ret                                                   
                  long          0-0                         

                                                             'endfunc


Getdepth                                                     'Func Getdepth 'xa, yb


'   _x   var long=0     '    double x = 0, x2, y = 0;        '  _x   var long=0     '    double x = 0, x2, y = 0;

'   _x2  var long=0                                          '  _x2  var long=0

'   _y   var long=0                                          '  _y   var long=0

'   n    var long=0                                          '  n    var long=0

'   _temp var long                                           '  _temp var long

'   _temp2 var long                                          '  _temp2 var long



                  mov           _x,#0                        '  _x = 0

                  mov           _y,#0                        '  _y = 0

                  mov           _x2,#0                       '  _x2 = 0


                  mov           n,#0                         '  for n = 0 to 64    'for (int n = 0; n < 400; n++) {
__FOR_n_2                                                   

                  mov           __temp1,_x                   '     _x2 = _x */ _x   'x2 = x * x - y * y + a;
                  mov           __temp2,_x                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0037                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0037 - @__Init          
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _x2,__temp1                 

                  mov           __temp1,_y                   '     _temp = _y */ _y
                  mov           __temp2,_y                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0038                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0038 - @__Init          
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _temp,__temp1               

                  subs          _x2,_temp                    '     dec _x2, _temp

                  adds          _x2,__param1                 '     inc _x2, __param1


                  mov           __temp1,_y                   '     _y = _y */ _x   'y = 2 * x * y + b;
                  mov           __temp2,_x                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0039                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0039 - @__Init          
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _y,__temp1                  

                  shl           _y,#1                        '     _y = _y * 2

                  adds          _y,__param2                  '     inc _y , __param2


                  mov           _x,_x2                       '     _x = _x2        'x = x2;


                  mov           __temp1,_x                   '     _temp = _x */ _x         'if (x * x + y * y > 4)
                  mov           __temp2,_x                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0040                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0040 - @__Init          
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _temp,__temp1               

                  mov           __temp1,_y                   '     _temp2 = _y */ _y
                  mov           __temp2,_y                  
                  abs           __temp1,__temp1 WC          
                  muxc          __temp3,#1                  
                  abs           __temp2,__temp2 WC, WZ      
    IF_C          xor           __temp3,#1                  
                  mov           __temp4,#0                  
                  mov           __temp5,#32                 
                  shr           __temp1,#1 WC               
__L0041                                                     
    IF_C          add           __temp4,__temp2 WC          
                  rcr           __temp4,#1 WC               
                  rcr           __temp1,#1 WC               
                  djnz          __temp5,#_LMM_JUMP          
                  long          @__L0041 - @__Init          
                  shr           __temp1,#16                 
                  shl           __temp4,#16                 
                  or            __temp1,__temp4             
                  test          __temp3,#1 WZ               
    IF_NZ         neg           __temp1,__temp1             
                  mov           _temp2,__temp1              

                  adds          _temp,_temp2                 '     inc _temp , _temp2


                  cmps          _temp,_262144 WZ, WC         '     if _temp > 262144 then '4*65536
    IF_BE         jmp           #_LMM_JUMP                  
                  long          __ELSE_9 * 4                

                  jmp           #_LMM_JUMP                   '        exit
                  long          __NEXT_n_2 * 4              

__ELSE_9                                                     '     endif
__ENDIF_9                                                   

                  adds          n,#1                         '  next n
                  cmps          n,#64 WZ, WC                
    IF_BE         jmp           #_LMM_JUMP                  
                  long          __FOR_n_2 * 4               
__NEXT_n_2                                                  


                  mov           __param1,n                   '  return n
                  rdlong        __PC,__PC                   
Getdepth_ret                                                
                  long          0-0                         

                                                             '  endfunc







Point                                                        'FUNC Point ' X, Y

                  mov           __param3,par                 '  __param3 = GetAddr VidMem

                                                             '  __param2 = __param2 << 5        ' y = y * 32 bytes per row
                  shl           __param2,#5                 

                                                             '  __param3 = __param3 + __param2  ' Address = Address + (y * 32)
                  adds          __param3,__param2           


                  mov           __param2,__param1            '  __param2 = __param1 >> 3        ' x / 8
                  shr           __param2,#3                 

                                                             '  __param3 = __param3 + __param2  ' Address = Address + (x / 8)
                  adds          __param3,__param2           


                  rdbyte        __param2,__param3            '  RDBYTE __param3, __param2       ' Read pixels at location


                                                             '  __param1 = __param1 & 7         ' X AND 7 (pixel position within byte)
                  and           __param1,#7                 

                  mov           __temp1,__param1             '  __param1 = 1 << __param1        ' Shift to make pixel mask
                  mov           __param1,#1                 
                  shl           __param1,__temp1            


                                                             '  __param1 = __param1 AND __param2 
                  and           __param1,__param2           

                  cmps          __param1,#0 WZ, WC           '  IF __param1 <> 0 THEN
    IF_E          jmp           #_LMM_JUMP                  
                  long          __ELSE_10 * 4               

                  mov           __param1,#1                  '    __param1 = 1

__ELSE_10                                                    '  ENDIF
__ENDIF_10                                                  

                  rdlong        __PC,__PC                    '  RETURN __param1
Point_ret                                                   
                  long          0-0                         

                                                             'ENDFUNC


CPlot                                                        'SUB CPlot ' X (__param1), Y(__param2), Color

                  mov           temp1,__param3               '  Temp1 = __param3

                  mov           __param3,par                 '  __param3 = GetAddr VidMem 'VidBuf

                                                             '  __param2 = __param2 << 5        ' y = y * 32 bytes per row
                  shl           __param2,#5                 

                                                             '  __param3 = __param3 + __param2  ' Address = Address + (y * 32)
                  adds          __param3,__param2           


                  mov           __param2,__param1            '  __param2 = __param1 >> 3        ' x / 8
                  shr           __param2,#3                 

                                                             '  __param3 = __param3 + __param2  ' Address = Address + (x / 8)
                  adds          __param3,__param2           


                  rdbyte        __param2,__param3            '  RDBYTE __param3, __param2       ' Read pixels at location


                                                             '  __param1 = __param1 & 7         ' X AND 7 (pixel position within byte)
                  and           __param1,#7                 

                  mov           __temp1,__param1             '  __param1 = 1 << __param1        ' Shift to make pixel mask
                  mov           __param1,#1                 
                  shl           __param1,__temp1            

                  cmps          temp1,#1 WZ, WC              '  if temp1 = 1 then
    IF_NE         jmp           #_LMM_JUMP                  
                  long          __ELSE_11 * 4               

                                                             '     __param2 = __param2 OR __param1 ' Xor byte with pixel mask
                  or            __param2,__param1           

                  jmp           #_LMM_JUMP                   '  else
                  long          __ENDIF_11 * 4              
__ELSE_11                                                   

                                                             '     __param2 = __param2 andn __param1
                  andn          __param2,__param1           

__ENDIF_11                                                   '  endif

                  wrbyte        __param2,__param3            '  WRBYTE __param3, __param2       ' Save pixels back

                  rdlong        __PC,__PC                    'ENDSUB
CPlot_ret                                                   
                  long          0-0                         
                                                            


                                                             ''###########################################################################################################################################
DAT                                                          'TASK Calc1
  '-------------------------------------------------------------------------------------------
  'LMM Execution code                                       
  ' -------------------------------------------------------------------------------------------
                                                            
  ORG 0                                                     
                                                            
_LMM_Entry                                                  
                  mov           __PC,__OFFSET               
                                                            
_LMM_LOOP                                                   
                  rdlong        __INSTR1,__PC               
                  add           __PC,#4                     
__INSTR1                                                    
                  nop           ' Placeholder for LMM instruction
                                                            
                  rdlong        __INSTR2,__PC               
                  add           __PC,#4                     
__INSTR2                                                    
                  nop           ' Placeholder for LMM instruction
                                                            
                  rdlong        __INSTR3,__PC               
                  add           __PC,#4                     
__INSTR3                                                    
                  nop           ' Placeholder for LMM instruction
                                                            
                  rdlong        __INSTR4,__PC               
                  add           __PC,#4                     
__INSTR4                                                    
                  nop           ' Placeholder for LMM instruction
                                                            
                  jmp           #_LMM_LOOP                  
                                                            
_LMM_JUMP                                                   
                  rdlong        __PC,__PC                   
                  add           __PC,__OFFSET               
                  jmp           #_LMM_LOOP                  
                                                            
_LMM_CALL                                                   
                  rdlong        __temp1,__PC                
                  add           __temp1,__OFFSET            
                  add           __PC,#8                     
                  wrlong        __PC,__temp1                
                  sub           __PC,#4                     
                  rdlong        __PC,__PC                   
                  add           __PC,__OFFSET               
                  jmp           #_LMM_LOOP                  
                                                            
_LMM_MOVS                                                   
                  rdlong        __MOVS,__PC                 
                  movs          __MOVS,__INDEX              
                  add           __PC,#4                     
__MOVS                                                      
                  nop           ' Placeholder for LMM instruction
                  jmp           #_LMM_LOOP                  
                                                            
_LMM_MOVD                                                   
                  rdlong        __MOVD,__PC                 
                  movd          __MOVD,__INDEX              
                  add           __PC,#4                     
__MOVD                                                      
                  nop           ' Placeholder for LMM instruction
                  jmp           #_LMM_LOOP                  
                                                            
                  '             Variables for LMM execution code
__INDEX          LONG 0  ' Used by MOVS and MOVD            
__OFFSET         LONG 0-0' Set by spin                      
__PC             LONG 0  ' Program counter                  
'**********************************************************************
__InitDirA       LONG %01000000_10000000_01010000_00000000
__InitOutA       LONG %01000000_00000000_00000000_00000000
_minushex1fff    LONG -$1fff
_minushex1000    LONG -$1000
_115200baud      LONG 694
_2047            LONG 2047
_2048            LONG 2048
_hex800          LONG $800
_hex1000         LONG $1000
SyncPin          LONG 1 << 12
_hex1fff         LONG $1fff
__XMinH_ofs      LONG XMinH_ofs
__XMaxH_ofs      LONG XMaxH_ofs
__YMinH_ofs      LONG YMinH_ofs
__YMaxH_ofs      LONG YMaxH_ofs
__valueStr_ofs   LONG valueStr_ofs
__CR_ofs         LONG CR_ofs
VideoPin         LONG 1 << 14
_20000           LONG 20000
_hexE000         LONG $E000
_hexffff         LONG $ffff
CpSync           LONG 1 << 16
_65536          
ONE              LONG 65536
_1mSec           LONG 80000
_262144          LONG 262144
Ready4           LONG 1 << 19
_1000000         LONG 1000000
Ready3           LONG 1 << 20
ReadyTwo         LONG 1 << 21
ReadyOne         LONG 1 << 22
StartCalc        LONG 1 << 23
_FREQ            LONG 80000000
TX               LONG 1 << 30

xmin             LONG -131072
xmax             LONG -65000
ymin             LONG -98304
ymax             LONG -32000
xstep            LONG 65000
scanangle        LONG 0
deltaangle       LONG 1000
rcount           LONG 0
_x               LONG 0
_x2              LONG 0
_y               LONG 0
n                LONG 0

__remainder
__temp1          RES 1
__temp2          RES 1
__temp3          RES 1
__temp4          RES 1
__temp5          RES 1
__param1         RES 1
__param2         RES 1
__param3         RES 1
__param4         RES 1
__paramcnt       RES 1
vidAddr          RES 1
bufAddr          RES 1
x                RES 1
y                RES 1
x1               RES 1
y1               RES 1
seed             RES 1
temp             RES 1
temp1            RES 1
value            RES 1
ystep            RES 1
help             RES 1
scanradius       RES 1
xmid             RES 1
ymid             RES 1
mdepth           RES 1
scale            RES 1
anglec           RES 1
cos              RES 1
angle            RES 1
quadrant         RES 1
index            RES 1
sinus            RES 1
angle2           RES 1
ang1             RES 1
ang2             RES 1
ang              RES 1
qsum             RES 1
pix              RES 1
oldpix           RES 1
_temp            RES 1
_temp2           RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  vidMem_ofs                       = 0
  vidBuf_ofs                       = 6144
  XMinH_ofs                        = 12288
  XMaxH_ofs                        = 12292
  YMinH_ofs                        = 12296
  YMaxH_ofs                        = 12300
  valueStr_ofs                     = 12304
  CR_ofs                           = 12316
  MonoVid_COG_ofs                  = 12320
  Calc1_COG_ofs                    = 12324
  Calc2_COG_ofs                    = 12328
  Calc3_COG_ofs                    = 12332
  Calc4_COG_ofs                    = 12336

'                                                           



                                                             ''###########################################################################################################################################

' TASK Calc2                                                 'TASK Calc2


                                                             ''###########################################################################################################################################

' TASK Calc3                                                 'TASK Calc3


                                                             ''###########################################################################################################################################

' TASK Calc4                                                 'TASK Calc4






                                                             ''###########################################################################################################################################


' TASK MonoVid                                               'TASK MonoVid



DAT
__DATASTART
vidMem           BYTE 0[6144]
vidBuf           BYTE 255[6144]
XMinH            LONG 0
XMaxH            LONG 0
YMinH            LONG 0
YMaxH            LONG 0
valueStr         BYTE 0[12]
CR
                 BYTE 13,0
MonoVid_COG      LONG 0
Calc1_COG        LONG 0
Calc2_COG        LONG 0
Calc3_COG        LONG 0
Calc4_COG        LONG 0


