PUB Init(pv_DataStart)                                      
  Return ((pv_DataStart >> 2) << 18) + ((@__INIT >> 2) << 4)
                                                            
DAT                                                         
  ORG 0                                                     
__INIT                                                      
                  mov           dira,__InitDirA             
                  mov           outa,__InitOutA             

'   addr      VAR LONG     ' Holds hub address of video memory being displayed '  addr      VAR LONG     ' Holds hub address of video memory being displayed

'   line      VAR LONG = 0 ' Holds vertical line being generated '  line      VAR LONG = 0 ' Holds vertical line being generated

'   segment   VAR LONG     ' Counts longs for each horizonal line '  segment   VAR LONG     ' Counts longs for each horizonal line

'   pixels    VAR LONG     ' Holds pixels being displayed    '  pixels    VAR LONG     ' Holds pixels being displayed

'   lineTimer VAR LONG     ' Used to generate each line every 64uSec '  lineTimer VAR LONG     ' Used to generate each line every 64uSec



                                                             '  ' Setup cnta to use video hardware
                  mov           ctra,_bin125829120           '  CTRA = %0_00001_111_00000000_000000_000_000000   ' Video PLL x16

                  mov           frqa,_hex19999999            '  FRQA = $1999_9999   ' = 8 Mhz FROM 80Mhz clock x 16PLL = 128MHz


                                                             '  ' Setup VSCL
                  mov           vscl,_hex162C0               '  VSCL = $16_2C0      ' Pixel clock = 128MHz / 22 = 5.818181MHz


                                                             '  ' Setup I/O pins
                  or            dira,SyncPin                 '  LOW SyncPin
                  andn          outa,SyncPin                

                  or            dira,VideoPin                '  LOW VideoPin
                  andn          outa,VideoPin               


                  mov           __temp2,#10                  '  PAUSE 10 ' Wait for video PLL to stabilize
                  mov           __temp1,_1mSec              
                  add           __temp1,cnt                 
__L0098                                                     
                  waitcnt       __temp1,_1mSec              
                  djnz          __temp2,#__L0098            


                                                             '  ' Setup for initial state
                  mov           addr,par                     '  addr = GetAddr VidMem

                  mov           lineTimer,cnt                '  lineTimer = CNT + 5120
                  adds          lineTimer,_5120             

__DO_17                                                      '  DO

                  waitcnt       lineTimer,_5120              '    WaitCnt LineTimer, 5120 ' Each line is 5120 clocks @ 80MHz = 64uSec per line

                  andn          outa,SyncPin                 '    SyncPin = 0

                  mov           __temp1,#376                 '    PAUSEUS 4.7 '4.7 ' Generate sync for 4.7uSec
                  add           __temp1,cnt                 
                  waitcnt       __temp1,#0                  

                                                             '    ' Line 0-2 = Sync; 3-36= Top Blank; 37-228 = Pixels; 229-261 = Bottom Blank
                  cmps          line,#0 WZ, WC               '    IF line > 0  THEN '3 <<< Hier ge?ndert!!!!
    IF_BE         jmp           #__ELSE_24                  

                  or            outa,SyncPin                 '      SyncPin = 1

                  mov           __temp1,#280                 '      PAUSEUS 3.5 '3 ' Left Margin
                  add           __temp1,cnt                 
                  waitcnt       __temp1,#0                  

                  cmps          line,#36 WZ, WC              '      IF line > 36 THEN '36
    IF_BE         jmp           #__ELSE_25                  

                  or            dira,CpSync                  '        low CpSync
                  andn          outa,CpSync                 

                  cmps          line,#229 WZ, WC             '        IF line < 229 THEN '229
    IF_AE         jmp           #__ELSE_26                  

                                                             '          ' Setup VCFG to send one line of pixels
                  mov           vcfg,_bin536871488           '          VCFG = %0_01_0_0_0_000_00000000000_001_0_0100_0000

                  mov           segment,#0                   '          FOR segment = 0 TO  7 '8 * 32 = 256 pixels per line
__FOR_segment_15                                            

                  rdlong        pixels,addr                  '            RdLong addr, pixels

                  waitvid       _hexFF00,pixels              '            WaitVid $FF00, pixels

                  adds          addr,#4                      '            inc addr , 4

                  adds          segment,#1                   '          NEXT
                  cmps          segment,#7 WZ, WC           
    IF_BE         jmp           #__FOR_segment_15           
__NEXT_segment_15                                           

                                                             '          ' Stop generating pixels
                  mov           __temp1,#0                   '          WaitVid 0,0
                  waitvid       __temp1,#0                  

                  mov           vcfg,#0                      '          VCFG = 0

__ELSE_26                                                    '        ENDIF
__ENDIF_26                                                  

__ELSE_25                                                    '      ENDIF
__ENDIF_25                                                  

__ELSE_24                                                    '    ENDIF
__ENDIF_24                                                  

                  adds          line,#1                      '    INC line

                  cmps          line,#262 WZ, WC             '    IF line = 262 THEN '262
    IF_NE         jmp           #__ELSE_27                  

                                                             '      ' Reset for new frame
                  mov           line,#0                      '      line = 0

                  mov           addr,par                     '      addr = GetAddr VidMem

                  or            dira,CpSync                  '      high CpSync
                  or            outa,CpSync                 

__ELSE_27                                                    '    ENDIF
__ENDIF_27                                                  


                  jmp           #__DO_17                     '  LOOP
__LOOP_17                                                   

                  mov           __temp1,#0                   'ENDTASK
                  waitpne       __temp1,__temp1             
'**********************************************************************
__InitDirA       LONG %00000000_00000000_00000000_00000000
__InitOutA       LONG %00000000_00000000_00000000_00000000
SyncPin          LONG 1 << 12
_5120            LONG 5120
VideoPin         LONG 1 << 14
_hexFF00         LONG $FF00
CpSync           LONG 1 << 16
_1mSec           LONG 80000
_hex162C0        LONG $16_2C0
_bin125829120    LONG %0_00001_111_00000000_000000_000_000000
_hex19999999     LONG $1999_9999
_bin536871488    LONG %0_01_0_0_0_000_00000000000_001_0_0100_0000

line             LONG 0

__remainder
__temp1          RES 1
__temp2          RES 1
__temp3          RES 1
__temp4          RES 1
__temp5          RES 1
__param1         RES 1
__param2         RES 1
__param3         RES 1
__param4         RES 1
__paramcnt       RES 1
addr             RES 1
segment          RES 1
pixels           RES 1
lineTimer        RES 1

FIT 492

CON
  LSBFIRST                         = 0
  MSBFIRST                         = 1
  MSBPRE                           = 0
  LSBPRE                           = 1
  MSBPOST                          = 2
  LSBPOST                          = 3
  vidMem_ofs                       = 0
  vidBuf_ofs                       = 6144
  XMinH_ofs                        = 12288
  XMaxH_ofs                        = 12292
  YMinH_ofs                        = 12296
  YMaxH_ofs                        = 12300
  valueStr_ofs                     = 12304
  CR_ofs                           = 12316
  MonoVid_COG_ofs                  = 12320
  Calc1_COG_ofs                    = 12324
  Calc2_COG_ofs                    = 12328
  Calc3_COG_ofs                    = 12332
  Calc4_COG_ofs                    = 12336
